﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;

namespace WinGridRecursiveRelation
{
    public partial class WinGridRecursion : Form
    {
        private BindingSource _bindingSource;
        private DataSet _dataSet = new DataSet();
        private DataTable _dtTable1 = new DataTable("Table1");
        private DataTable _dtTable2 = new DataTable("Table2");

        private DataRelation _drNestedRelation;

        private string _key = "KeyValue";
        private int _sequence = 0;

        public WinGridRecursion()
        {
            InitializeComponent();
        }

        private void WinGridRecursion_Load(object sender, EventArgs e)
        {
            SetUpDataSource();
        }

        private void SetUpDataSource()
        {
            try
            {
                _dtTable1.Columns.Add("Key1");
                _dtTable1.Columns.Add("Sequence1", System.Type.GetType("System.Int32"));
                _dtTable1.Columns.Add("Tbl1_AAA");
                _dtTable1.Columns.Add("Tb11_BBB");
                _dtTable1.Columns.Add("FK_Key1");
                _dtTable1.Columns.Add("FK_Sequence1", System.Type.GetType("System.Int32"));

                //_dtTable2.Columns.Add("Key1");
                //_dtTable2.Columns.Add("Sequence1", System.Type.GetType("System.Int32"));
                //_dtTable2.Columns.Add("Tbl2_CCC");
                _dtTable2.Columns.Add("Tbl2_DDD");

                _dataSet.Tables.Add(_dtTable1);
                //_dataSet.Tables.Add(_dtTable2);


                //_dataSet.Relations.Add("T1-T2", new DataColumn[] { _dataSet.Tables["Table1"].Columns["Key1"], _dataSet.Tables["Table1"].Columns["Sequence1"] },
                //                                new DataColumn[] { _dataSet.Tables["Table2"].Columns["Key1"], _dataSet.Tables["Table2"].Columns["Sequence1"] }, false);

                _drNestedRelation = _dataSet.Relations.Add("NestedRelation", new DataColumn[] { _dataSet.Tables["Table1"].Columns["Key1"], _dataSet.Tables["Table1"].Columns["Sequence1"] },
                                                new DataColumn[] { _dataSet.Tables["Table1"].Columns["FK_Key1"], _dataSet.Tables["Table1"].Columns["FK_Sequence1"] }, false);

                _drNestedRelation.Nested = true;

                ultraGrid1.DisplayLayout.MaxBandDepth = 5;
                _bindingSource = new BindingSource(_dataSet, "");
                ultraGrid1.DataSource = _bindingSource;
                //ultraGrid1.DataSource = _dataSet;     // Using the dataset instead of bindingsource works
            }   
            catch (Exception ex)
            {
                throw ex;
            }
        }
        private void ultraGrid1_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            e.Layout.GroupByBox.Hidden = true;
            e.Layout.AddNewBox.Hidden = false;
            e.Layout.AddNewBox.Style = AddNewBoxStyle.Compact;
            foreach (UltraGridBand band in e.Layout.Bands)
            {
                band.Override.AllowAddNew = AllowAddNew.Yes;
                band.Override.RowSelectors = DefaultableBoolean.True;
                band.Override.RowSizing = RowSizing.AutoFree;
            }
        }

        private void ultraGrid1_InitializeRow(object sender, InitializeRowEventArgs e)
        {
            switch (e.Row.Band.Key)
            {
                case "Table1":
                    if (e.Row.Cells["FK_Key1"].Value != DBNull.Value)
                    {
                        e.Row.Hidden = true;
                    }
                    break;
            }
        }

        private void ultraGrid1_AfterRowInsert(object sender, RowEventArgs e)
        {
            e.Row.Cells["Key1"].Value = _key;
            switch (e.Row.Band.Key)
            {
                case "Table1":
                    _sequence++;
                    e.Row.Cells["Sequence1"].Value = _sequence;
                    break;

                case "NestedRelation":
                    _sequence++;
                    e.Row.Cells["Sequence1"].Value = _sequence;
                    e.Row.Cells["FK_Key1"].Value = e.Row.ParentRow.Cells["Key1"].Value;
                    e.Row.Cells["FK_Sequence1"].Value = e.Row.ParentRow.Cells["Sequence1"].Value;
                    break;

                //case "Table2":

                //    e.Row.Cells["Sequence1"].Value = e.Row.ParentRow.Cells["Sequence1"].Value;
                //    break;
            }
            ultraGrid1.UpdateData();

        }
    }
}
